(function () {
    "use strict";

    angular.module('core').controller('naturezaOperacaoDetailController', controller);
    controller.$inject = ['$scope', '$timeout', '$state', '$stateParams', 'naturezaOperacaoService', 'lookupService', '$q','$alert'];

    function controller($scope, $timeout, $state, $stateParams, naturezaOperacaoService, lookupService, $q, $alert) {
        $scope.initializeLayout('Natureza de Operação');

        //[Inicializa objetos]
        $scope.state = {
            item: { ID: decodeURIComponent($stateParams.id) },
            carregando: false,
            vazio: false,
            IndicaDentroEstado : false
        };

        $scope.save = function () {
            $scope.state.salvando = true;
            $scope.state.item.Loja.IndicaDentroEstado = $scope.state.IndicaDentroEstado;
            naturezaOperacaoService
                .save($scope.state.item)
                .then(
                function (response) {
                    if (response.Status < 0) {
                        $scope.state.salvando = false;
                        $alert({ text: response.Message, title: $scope.Title });
                    } else {
                        $scope.historyBack();
                    }
                },
                function (_error) {
                    $scope.state.salvando = false;
                    $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                });
        }
        $scope.delete = function () {
            $scope.state.carregando = true;
            $scope.state.vazio = false;
            naturezaOperacaoService
                .delete($scope.state.item.ID)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $alert({ text: response.Message, title: $scope.Title });
                        }
                        else {
                            $scope.historyBack();
                        }
                        $scope.state.carregando = false;
                        $scope.state.vazio = !$scope.state.item;
                    },
                    function (_error) {
                        $scope.state.carregando = false;
                        $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                    }
                );
        }
        
        $scope.auxiliar = {
            grupofiscaloperacao: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllGrupoFiscalOperacao({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
             naturazaoperacaoloja: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllNaturezaOperacao({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            }
        };

        //[Inicializa funcões]
        $scope.initialize = function () {
            $scope.refresh();
        };

        $scope.get = function () {
            $scope.state.carregando = true;
            $scope.state.vazio = false;
            naturezaOperacaoService
                .get($scope.state.item)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                            console.error(response.Exception);
                        } else {
                            
                            $scope.state.item = response.Data;
                            $scope.state.item.Loja.Nome = $scope.state.item.Loja.Codigo 
                            $scope.state.IndicaDentroEstado = $scope.state.item.Loja.IndicaDentroEstado;
                        }
                        $scope.state.carregando = false;
                        $scope.state.vazio = !$scope.state.item;
                    },
                    function (_error) {
                        $scope.state.carregando = false;
                        $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                        console.error(_error);
                    }
                );
        };
        $scope.refresh = function () {
            $scope.get();
        };

        /*Inicializa funções*/
        $scope.initialize();

    }

})();